class ArtifactInvulnerability extends RPGArtifact;

var Material EffectOverlay;

function BotConsider()
{
	if (Instigator.Controller.Adrenaline < 30)
		return;

	if (bActive && (Instigator.Controller.Enemy == None || !Instigator.Controller.CanSee(Instigator.Controller.Enemy)))
		Activate();
	else if ( !bActive && Instigator.Controller.Enemy != None
		  && Instigator.Health < 70 && Instigator.Controller.CanSee(Instigator.Controller.Enemy) && NoArtifactsActive() && FRand() < 0.7 )
		Activate();
}

state Activated
{
	function BeginState()
	{
		Instigator.Controller.bGodMode = true;
		Instigator.SetOverlayMaterial(EffectOverlay, Instigator.Controller.Adrenaline / CostPerSec, true);
		bActive = true;
	}

	function EndState()
	{
		if (Instigator != None)
		{
			Instigator.SetOverlayMaterial(EffectOverlay, -1, true);
			if (Instigator.Controller != None)
				Instigator.Controller.bGodMode = false;
		}
		bActive = false;
	}
}

defaultproperties
{
	EffectOverlay=Shader'UTRPGTextures.Overlays.InvulnerabilityOverlay'
	CostPerSec=12
	PickupClass=class'ArtifactInvulnerabilityPickup'
	ItemName="Globe of Invulnerability"
	IconMaterial=Material'UTRPGTextures.Icons.InvulnerabilityIcon'
}
